#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdint.h>
#include <propeller.h>
#include <tvText.h>

extern int _hardware;
extern int _cpu_config;
extern int ZPU_ID;
extern int _use_syscall;

#define SYS_read  4
#define SYS_write 5

void box(int left, int top, int width, int height, int color);

#define TVTEXT_FILENO 4

int main (int argc,  char* argv[])
{
    int  result;

	char outstr[100];

    iprintf("Hello world\n");

    siprintf(outstr, "The meaning of life = %d\n", 42);
	iprintf(outstr);

	// Print some libgloss/crt stuff
	iprintf("argc = %d\n",argc);
	iprintf("&argv [0]= %d\n",argv);

    if(0) {
        int  n = 0;
        result = tvText_start(20);
        iprintf("TvText COG %x\n", result);
	    tvText_str("Hello World Again!\n");

        for(n = 0; 0 && n < 64; n++) {
            if(n % 8 == 0) {
	            tvText_out('\n');
                //iprintf("\n");
            }
	        tvText_hex(n,4);
            //iprintf("%04x ", n);
        }
    }

    result = tvText_start(20);
    iprintf("TvText COG %x\n", result);
	tvText_str("Hello World Again!\n");

    box(4,4,5,5,1);

	iprintf("\n\nBye!\n");

	return(0);
}

extern volatile TvText_t *tvPtr;

inline void boxchr(int boxcolor, int c, uint16_t *screenptr)
{
    int val = ((boxcolor << 1 | c & 1) << 10) + 0x200 + (c & 0xFE);
    val = (boxcolor << 10) + 0x200 + c;
	//iprintf("Screenptr %04x %04x ",screenptr,*screenptr, val);
    //*screenptr = (boxcolor << 10) + 0x200 + c;
    *screenptr = val;
	//iprintf("%04x\n",*screenptr);
}

// Draw a box
//
void box(int left, int top, int width, int height, int color)
{
    int n;
    int cols = tvText_getColumns();
    int ptr = top * cols + left;

    uint16_t* screen = tvPtr->screen;
	iprintf("\nScreen %x\n",screen);

    boxchr(color,0,&screen[ptr++]);

    for (n=1; n < width; n++) {
        boxchr(color,0xC,&screen[ptr++]);
    }

    boxchr(color,0x8,&screen[ptr]);
    for (n=1; n < width; n++) {
        ptr = (top + n) * cols + left;
        boxchr(color,0xA,&screen[ptr++]);
        ptr += width;
        boxchr(color,0xB,&screen[ptr++]);
    }

    ptr = (top + height + 1) * cols + left;

    boxchr(color,0x1,&screen[ptr++]);
    for (n=1; n < width; n++) {
        boxchr(color,0xD,&screen[ptr++]);
    }

    boxchr(color,0x9,&screen[ptr++]);
}
